/*
** Copyright (C) 2007 felix <felixmatenaar@web.de>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <inttypes.h>

#include "lcd.h"
#include "lcdmenu.h"


uint8_t cur_page   = 0;
Page*   menu_pages = NULL;

/*
uint8_t 
page_direction(Page* page, int8_t direction)
//{{{
{
	
  page->cur_action += direction;
	if (page->cur_action < 0)
		page->cur_action += page->num_actions;
	else if (page->cur_action >= page->num_actions)
		page->cur_action -= page->num_actions;

	lcd_gotoxy (page->act_pos_x[page->cur_action],page->act_pos_y[page->cur_action]);


	return page->cur_action;
}	
//}}}
*/

int8_t
page_display(uint8_t new_page)
//{{{
{
	Page* page = &(menu_pages[new_page]);

	if ((new_page >= NUM_PAGES) || (page == NULL))
		return -1; // new_page does not exist
	
	cur_page = new_page;

	lcd_clrscr();

	for (uint8_t i = 0; i < LCD_LINES; i++)
  	{
			lcd_gotoxy(0,i);
			lcd_puts(page->line[i]);
  	}

	lcd_gotoxy(page->act_pos_x[page->cur_action],page->act_pos_y[page->cur_action]); // set cursor to action position


	return 1; // new_page is being displayed
}
//}}}

///////// FUNCTIONS FOR PAGE INITIALISATION ////////////////////////////////////////////////////////
int8_t
page_init_screen(Page* page, char* lines[])
//{{{
{
	if(page == NULL)
		return -1;
	
	memset(page->line,' ',sizeof(LCD_LINES*LCD_DISP_LENGTH));

	for (uint8_t i = 0; i < LCD_LINES; i++)
		strncpy(page->line[i],lines[i],LCD_DISP_LENGTH+1);

	return 0;
}
//}}}

void
page_reserve(Page* page, uint8_t num_actions)
//{{{
{
	page->act_pos_x = malloc(sizeof(uint8_t) * num_actions);	
	page->act_pos_y = malloc(sizeof(uint8_t) * num_actions);	
	page->p_acts    = malloc(sizeof(int8_t*) * num_actions);	
	page->num_actions = num_actions;
}
//}}}

int8_t
page_add_action(Page* page, uint8_t act_pos_x, uint8_t act_pos_y, int8_t (*action)(Page*), uint8_t pos_action)
//{{{
{
	if(pos_action >= page->num_actions)
		return -1;		

	page->act_pos_x[pos_action] = act_pos_x;
	page->act_pos_y[pos_action] = act_pos_y;
	page->p_acts[pos_action] = (void*)action;

	page->cur_action = 0; // initialise cur_action of page (could be done elsewhere)
	
	return 0;
}
//}}}

